<?php
/***********************************************************************
 * YAC - Yes, Another Cms !
 * version 0-1-04b	oct 2014
 *
 * Copyright 2014 Jean-Marc LELIEVRE <yac-cms@yandex.com>
 * http://yac.wizekat.eu/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
***********************************************************************/
function bakfile($filename) {

// ou est la page ?
$localdir = dirname(realpath(__FILE__));
// pages du site
$ori = "files/$filename";
  if (file_exists("$localdir/$ori")) {
  // sauvegarde la page
  $bak = "files/backup/$filename~".date("H");
  define("PAGE_FILENAME",$ori);
  $file = @fopen($bak, "w");
    if (!$file) {
    return false;
    }
    else {
    $sauve = @file_get_contents($ori);
    fwrite($file, $sauve);
    fclose($file);
    return true;
    }
  }
  
  else {
  // modules
  $found = false;
  if (file_exists("$localdir/modules")) {
  $rep=opendir("$localdir/modules");
    while ($file = readdir($rep)){
    $file = trim(chop($file));
      if ($file != "." && $file != ".." && $file != "_disabled" && is_dir("$localdir/modules/$file")) {   
      $mod=opendir("$localdir/modules/$file");
	while ($module = readdir($mod)){
	$module = trim(chop($module));
	  if (is_dir("$localdir/modules/$file/$module")) {
	    if (file_exists("$localdir/modules/$file/$module/files/$filename")) {
	    // sauvegarde la page
	    $bak = "$localdir/modules/$file/$module/files/backup/$filename~".date("H");
	    $ori = "$localdir/modules/$file/$module/files/$filename";
	    define("PAGE_FILENAME",$ori);
	    $file = @fopen($bak, "w");
	      if (!$file) {
	      return false;
	      }
	      else {
	      $sauve = @file_get_contents($ori);
	      fwrite($file, $sauve);
	      fclose($file);
	      return true;
	      }
	    }
	  }
	}
      closedir($mod);
      }
    }
  closedir($rep);
  }
  }
  
    if ($found == false) {
  // new page
  $bak = "files/backup/$filename~".date("H");
  define("PAGE_FILENAME",$ori);
  $file = @fopen($bak, "w");
    if (!$file) {
    return false;
    }
    else {
    $sauve = @file_get_contents($ori);
    fwrite($file, $sauve);
    fclose($file);
    return true;
    }
  
  }

}

// controle d'accès
session_start();
$encrypt_pass = @file_get_contents('files/password');
  if($_SESSION['l']!=$encrypt_pass){
  header('HTTP/1.1 401 Unauthorized');
  exit;
  }

$fieldname = $_REQUEST['fieldname'];
$content = trim(rtrim(stripslashes($_REQUEST['content'])));

// controle de sauvegarde
  if (bakfile($fieldname)) {
    if (!defined("PAGE_FILENAME")) {
    echo "Ce contenu ne peut pas être sauvegardé ou les permissions ne sont pas correctes.";
    exit;
    }
  $file = @fopen(PAGE_FILENAME, "w");
  }
  else {
  echo "Ce contenu ne peut pas être sauvegardé ou les permissions ne sont pas correctes.";
  exit;
  }

// controle de modification 
  if(!$file){
  echo "Ce contenu n'est pas modifiable ou les permissions ne sont pas correctes.";
  exit;
  }

// extraction du sql si besoin est  
$content3 = str_replace('!--sql',"sql",$content);
$content3 = str_replace('sql--',"sql",$content3);
$zone = "sql";
$pattern = "/<$zone>([\w\W]*?)<\/$zone>/";
preg_match($pattern,$content3,$match);
$rtn = $match[1];
  if ($rtn != "") {
  $dat = explode("</$zone>", $content3);
  $newcontent = $dat[0]."</$zone>"."\n";
  $content = $newcontent;
  }
  
// mise à jour du contenu
fwrite($file, $content);
fclose($file);
echo $content;

?>